<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOTA_HotelAvailRSRoomStaysRoomStay ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfOTA_HotelAvailRSRoomStaysRoomStay extends AbstractStructArrayBase
{
    /**
     * The RoomStay
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgRoomStay[]
     */
    public $RoomStay;
    /**
     * Constructor method for ArrayOfOTA_HotelAvailRSRoomStaysRoomStay
     * @uses DgArrayOfOTA_HotelAvailRSRoomStaysRoomStay::setRoomStay()
     * @param \dgsoft\StructType\DgRoomStay[] $roomStay
     */
    public function __construct(array $roomStay = array())
    {
        $this
            ->setRoomStay($roomStay);
    }
    /**
     * Get RoomStay value
     * @return \dgsoft\StructType\DgRoomStay[]|null
     */
    public function getRoomStay()
    {
        return $this->RoomStay;
    }
    /**
     * Set RoomStay value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRoomStay[] $roomStay
     * @return \dgsoft\ArrayType\DgArrayOfOTA_HotelAvailRSRoomStaysRoomStay
     */
    public function setRoomStay(array $roomStay = array())
    {
        foreach ($roomStay as $arrayOfOTA_HotelAvailRSRoomStaysRoomStayRoomStayItem) {
            // validation for constraint: itemType
            if (!$arrayOfOTA_HotelAvailRSRoomStaysRoomStayRoomStayItem instanceof \dgsoft\StructType\DgRoomStay) {
                throw new \InvalidArgumentException(sprintf('The RoomStay property can only contain items of \dgsoft\StructType\DgRoomStay, "%s" given', is_object($arrayOfOTA_HotelAvailRSRoomStaysRoomStayRoomStayItem) ? get_class($arrayOfOTA_HotelAvailRSRoomStaysRoomStayRoomStayItem) : gettype($arrayOfOTA_HotelAvailRSRoomStaysRoomStayRoomStayItem)), __LINE__);
            }
        }
        $this->RoomStay = $roomStay;
        return $this;
    }
    /**
     * Add item to RoomStay value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRoomStay $item
     * @return \dgsoft\ArrayType\DgArrayOfOTA_HotelAvailRSRoomStaysRoomStay
     */
    public function addToRoomStay(\dgsoft\StructType\DgRoomStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgRoomStay) {
            throw new \InvalidArgumentException(sprintf('The RoomStay property can only contain items of \dgsoft\StructType\DgRoomStay, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoomStay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgRoomStay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgRoomStay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgRoomStay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgRoomStay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgRoomStay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomStay
     */
    public function getAttributeName()
    {
        return 'RoomStay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfOTA_HotelAvailRSRoomStaysRoomStay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
